"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const Backoff_test_1 = require("./Backoff.test");
const CompositeBackoff_1 = require("./CompositeBackoff");
const ConstantBackoff_1 = require("./ConstantBackoff");
describe('CompositeBackoff', () => {
    const withBias = (bias) => new CompositeBackoff_1.CompositeBackoff(bias, new ConstantBackoff_1.ConstantBackoff(10, 4), new ConstantBackoff_1.ConstantBackoff(20, 2));
    it('biases correctly', () => {
        var _a, _b, _c, _d;
        chai_1.expect((_a = withBias('a').next(undefined)) === null || _a === void 0 ? void 0 : _a.duration).to.equal(10);
        chai_1.expect((_b = withBias('b').next(undefined)) === null || _b === void 0 ? void 0 : _b.duration).to.equal(20);
        chai_1.expect((_c = withBias('min').next(undefined)) === null || _c === void 0 ? void 0 : _c.duration).to.equal(10);
        chai_1.expect((_d = withBias('max').next(undefined)) === null || _d === void 0 ? void 0 : _d.duration).to.equal(20);
    });
    it('limits the number of retries', () => {
        Backoff_test_1.expectDurations(withBias('max'), [20, 20, undefined]);
    });
});
//# sourceMappingURL=CompositeBackoff.test.js.map